"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var executeMiddlewares = function executeMiddlewares(middlewares, webSocket, resolve) {
  if (middlewares.length === 0) {
    var upgradeReq = webSocket.upgradeReq;
    resolve({
      req: upgradeReq
    });
  } else {
    var nextMiddleware = middlewares[0];
    var remainingMiddlewares = middlewares.slice(1);
    var response = {};
    nextMiddleware(webSocket.upgradeReq, response, function () {
      return executeMiddlewares(remainingMiddlewares, webSocket, resolve);
    });
  }
};

var createSubscriptionOnConnect = function createSubscriptionOnConnect(middlewares) {
  // This is called on each message that has a GQL_CONNECTION_INIT message type
  var onConnect = function onConnect(connectionParams, webSocket) {
    return new Promise(function (resolve) {
      return executeMiddlewares(middlewares, webSocket, resolve);
    });
  };

  return onConnect;
};

var _default = createSubscriptionOnConnect;
exports["default"] = _default;
//# sourceMappingURL=createSubscriptionOnConnect.js.map